//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1  PaleVioletRed
#property indicator_color7  DarkGray
#property indicator_width1  2

//
//
//
//
//

extern int  EMAPeriod = 14;
extern int  EMAPrice  = PRICE_CLOSE;
double ema[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,ema);
   return(0);
}
int deinit() { return(0); }

//
//
//
//
//

double work[][2];
#define _ema10 0
#define _ema11 1

int start()
{
   double alpha = 2.0/(1.0+EMAPeriod);
   int i,r,counted_bars=IndicatorCounted();
      if (counted_bars<0) return(0);
      if (counted_bars>0) counted_bars--;
            int limit=MathMin(Bars-counted_bars,Bars-1);
            if (ArrayRange(work,0) != Bars) ArrayResize(work,Bars);
 
   //
   //
   //
   //
   //
 
   for(i=limit, r=Bars-i-1; i>=0; i--,r++)
   {
      double price = iMA(NULL,0,1,0,MODE_SMA,EMAPrice,i);
         work[r][_ema10] = work[r-1][_ema10]+alpha*(price                -work[r-1][_ema10]);
         work[r][_ema11] = work[r-1][_ema11]+alpha*(price-work[r][_ema10]-work[r-1][_ema11]);
         ema[i]          = work[r][_ema10]+work[r][_ema11];
   }
   return(0);
}